# Summary

[소개](intro.md)

* [안전함과 불안전함을 마주하라](meet-safe-and-unsafe.md)
  * [안전함과 불안전함은 어떻게 상호작용하는가](safe-unsafe-meaning.md)
  * [불안전함은 어떤 것을 할 수 있는가](what-unsafe-does.md)
  * [불안전함과 함께 일하는 것](working-with-unsafe.md)
* [데이터 레이아웃](data.md)
  * [repr(Rust)](repr-rust.md)
  * [이량 타입](exotic-sizes.md)
  * [다른 표현 방식들](other-reprs.md)
* [소유권](ownership.md)
  * [레퍼런스](references.md)
  * [복제](aliasing.md)
  * [수명](lifetimes.md)
  * [수명의 한계](lifetime-mismatch.md)
  * [수명 생략](lifetime-elision.md)
  * [무제한 수명](unbounded-lifetimes.md)
  * [상계 트레잇 제한](hrtb.md)
  * [부분타입 다형성과 변성](subtyping.md)
  * [해제 검사](dropck.md)
  * [PhantomData](phantom-data.md)
  * [대여 쪼개기](borrow-splitting.md)
* [타입 변환](conversions.md)
  * [Coercions](coercions.md)
  * [The Dot Operator](dot-operator.md)
  * [Casts](casts.md)
  * [Transmutes](transmutes.md)
* [Uninitialized Memory](uninitialized.md)
  * [Checked](checked-uninit.md)
  * [Drop Flags](drop-flags.md)
  * [Unchecked](unchecked-uninit.md)
* [Ownership Based Resource Management](obrm.md)
  * [Constructors](constructors.md)
  * [Destructors](destructors.md)
  * [Leaking](leaking.md)
* [Unwinding](unwinding.md)
  * [Exception Safety](exception-safety.md)
  * [Poisoning](poisoning.md)
* [Concurrency](concurrency.md)
  * [Races](races.md)
  * [Send and Sync](send-and-sync.md)
  * [Atomics](atomics.md)
* [Implementing Vec](./vec/vec.md)
  * [Layout](./vec/vec-layout.md)
  * [Allocating](./vec/vec-alloc.md)
  * [Push and Pop](./vec/vec-push-pop.md)
  * [Deallocating](./vec/vec-dealloc.md)
  * [Deref](./vec/vec-deref.md)
  * [Insert and Remove](./vec/vec-insert-remove.md)
  * [IntoIter](./vec/vec-into-iter.md)
  * [RawVec](./vec/vec-raw.md)
  * [Drain](./vec/vec-drain.md)
  * [Handling Zero-Sized Types](./vec/vec-zsts.md)
  * [Final Code](./vec/vec-final.md)
* [Implementing Arc and Mutex](./arc-mutex/arc-and-mutex.md)
  * [Arc](./arc-mutex/arc.md)
    * [Layout](./arc-mutex/arc-layout.md)
    * [Base Code](./arc-mutex/arc-base.md)
    * [Cloning](./arc-mutex/arc-clone.md)
    * [Dropping](./arc-mutex/arc-drop.md)
    * [Final Code](./arc-mutex/arc-final.md)
* [FFI](ffi.md)
* [Beneath `std`](beneath-std.md)
  * [#[panic_handler]](panic-handler.md)
